#include <stdio.h>
#include <string.h>
#include <go32.h>
#include <dpmi.h>
#include "missing.h"
#include "defs.h"
#include "cpu.h"
#include "main.h"
#include "mem.h"
#include "screen.h"

#include <dos.h>
#include <bios.h>
#include <conio.h>
#include <stdlib.h>
#include <setjmp.h>

#include "ikbd.h"
#include "dosscan.h"
#include "io.h"

#include "dosdebug.h"

extern long tv_usec;
extern int hz200pt, vblpt, audio;
extern int vblcount, systcount;

static long timer_freq = 200;
static long timer_old = 0;
static long timerrate = 0;

static _go32_dpmi_seginfo tm_old;   /* original prot-mode timer IRQ */
static _go32_dpmi_seginfo tm_new;   /* prot-mode interrupt segment info*/

void hardware_jobs ( int );

static int timer_count = 0;

static void timer_handler ( void )
{
    hardware_jobs ( 0 );

    // call old interrupt with 18.2 Hz

//        if ( ++timer_count > timer_old )
//        {
//            timer_count = 0;
//            _chain_intr( prev_int_08 );
//        }

}

static int timer_handler_end;

void init_hardware ( void ) {

    lock_memory( timer_count, (int)sizeof(timer_count), 0);
    lock_memory( timer_old, (int)sizeof(timer_old), 0);

    lock_memory( timer_handler, (int)timer_handler_end-(int)timer_handler, 1);

    tm_new.pm_offset = (int)timer_handler;       /* pm handler */
    tm_new.pm_selector = _go32_my_cs();
    _go32_dpmi_get_protected_mode_interrupt_vector(8, &tm_old);
    _go32_dpmi_chain_protected_mode_interrupt_vector(8 , &tm_new);

    timer_freq = 1000000 / tv_usec;
    timer_old = (timer_freq*10/18.2+5)/10;
    timerrate = 1193180 / timer_freq;

    // setup timer
    disable();
    outportb ( 0x43, 0x36 );
    outportb ( 0x40, timerrate & 0xff );
    outportb ( 0x40, ( timerrate >> 8 ) & 0xff );
    enable();

    vblcount = vblpt;
    systcount = hz200pt;

    fprintf ( stderr, "DOS timer: %d hz hardware timer installed.\n", (int) timer_freq );
}

void kill_hardware ( void ) {
    // restore old timer handler
    _go32_dpmi_set_protected_mode_interrupt_vector(8, &tm_old);
    disable();
    outportb ( 0x43, 0x36 );
    outportb ( 0x40, 0 );
    outportb ( 0x40, 0 );
    enable();

    fprintf ( stderr, "DOS timer: hardware timer removed.\n" );
}

