#include <stdio.h>
#include <stdlib.h>
#include <bios.h>

#include "dos_ser2.h"

char *serial_dev = NULL;

static char port;
static char baud[]="19200";
static int serial_ok = 0;

void init_serial ( void ) {


    int retval;
    if ( serial_dev == NULL ) return;

    port = serial_dev[3];

    if ( port < '1' || port > '4' )
    {
        fprintf ( stderr, "DOS serial: only com1 to com4 supported!\n" );
        return;
    }
    retval = OpenComPort ( port );
    InitComPort ( baud, '8', 'N', '1' );

    if ( retval != -1 )
    {
        fprintf ( stderr, "DOS serial: using COM%c with %s baud as serial device.\n", port, baud );
        serial_ok = 1;
    }/*if*/
    else
        fprintf ( stderr, "DOS serial: cannot initialize COM%c.\n", port );
}

void done_serial ( void ) {

  if ( !serial_ok ) return;
  CloseComPort ();
  fprintf ( stderr, "DOS serial: serial removed.\n" );
  serial_ok = 0;
}

unsigned char read_serial ( void ) {

  unsigned char ch;

  if ( !serial_ok ) return 0;

  // look if we have characters waiting
  if ( serial_stat() == 0 ) return 0;

  ch = ComRecChar();

//  fprintf ( stderr, "received %d %c\n", ch, ch );

  return ch;
}

void write_serial ( unsigned char v ) {

  if ( !serial_ok ) return;

  ComSendChar ( v );

}

int serial_stat ( void ) {

  static int oldst, st;

  if ( !serial_ok ) return 0;

  st = ComStatus();

//  if ( st != oldst ) {
//      fprintf ( stderr, "status: %X\n", st );
//      oldst = st;
//  }

  if ( ( st & 0x100 ) == 0 ) return 0;
  else return 1;

}