/* This file is part of STonX, the Atari ST Emulator for Unix/X
 * ============================================================
 * STonX is free software and comes with NO WARRANTY - read the file
 * COPYING for details
 */
#include "defs.h"
#include "utils.h"
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
extern int verbose;

extern char exe_path[512];

void load_file (char *file, B *d)
{
   char temp[512];
	FILE *f = fopen(file, "rb");
	int l;

	if (f == NULL)
	{
      // DJ
      strcpy ( temp, exe_path );
      if ( strlen(temp)>0 && (temp[strlen(temp)-1] != '\\' && temp[strlen(temp)-1] != '/') )
        strcat ( temp, "\\" );
      strcat ( temp, file );
      if ( ( f = fopen ( temp, "rb" ) ) == NULL ) {
  		  fprintf (stdout, "Error: File `%s' not found!\n", temp);
		  exit(3);
      }/*if*/
	}
	verbose && fprintf (stderr, "Loading `%s'...", file);
	l = fread(d,1,300000,f); /* FIXME */
        verbose && fprintf ( stderr, "%ld bytes.\n", (long int) l );
	fclose ( f );
}

void error (char *fmt, ...)
{
	va_list args;
	va_start(args,fmt);
	fprintf( stdout, fmt, args);
  	va_end(args);
	exit(1);
}

int show_profile=0;

#if PROFILE
#include "proftabs.c"
void dump_profile (void)
{
	int i;
	if (!show_profile) return;
	for (i=0; i<NUM_OPCODES; i++)
	{
		printf("%20s %8d\n",prof_opname[i],prof_freq[i]);
	}
}

#else
void dump_profile(void)
{
}
#endif /* PROFILE */

void cleanup(int n)
{
	exit(n); /* sorry */
}

